/**
 * Autogenerated by Thrift Compiler (1.0.0-dev)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package jayeson.vodds.service.cms.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (1.0.0-dev)", date = "2022-4-26")
public class ThriftTransferPtPlForUser implements org.apache.thrift.TBase<ThriftTransferPtPlForUser, ThriftTransferPtPlForUser._Fields>, java.io.Serializable, Cloneable, Comparable<ThriftTransferPtPlForUser> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("ThriftTransferPtPlForUser");

  private static final org.apache.thrift.protocol.TField SERVICE_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("serviceId", org.apache.thrift.protocol.TType.STRING, (short)1);
  private static final org.apache.thrift.protocol.TField USER_IDS_FIELD_DESC = new org.apache.thrift.protocol.TField("userIds", org.apache.thrift.protocol.TType.I64, (short)2);
  private static final org.apache.thrift.protocol.TField CREDIT_FIELD_DESC = new org.apache.thrift.protocol.TField("credit", org.apache.thrift.protocol.TType.DOUBLE, (short)3);
  private static final org.apache.thrift.protocol.TField REMARK_FIELD_DESC = new org.apache.thrift.protocol.TField("remark", org.apache.thrift.protocol.TType.STRING, (short)4);
  private static final org.apache.thrift.protocol.TField IP_ADDRESS_FIELD_DESC = new org.apache.thrift.protocol.TField("ipAddress", org.apache.thrift.protocol.TType.STRING, (short)5);
  private static final org.apache.thrift.protocol.TField ALIAS_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("aliasId", org.apache.thrift.protocol.TType.I64, (short)6);
  private static final org.apache.thrift.protocol.TField IS_ALIAS_ACTIVITY_FIELD_DESC = new org.apache.thrift.protocol.TField("isAliasActivity", org.apache.thrift.protocol.TType.BOOL, (short)7);

  private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
  static {
    schemes.put(StandardScheme.class, new ThriftTransferPtPlForUserStandardSchemeFactory());
    schemes.put(TupleScheme.class, new ThriftTransferPtPlForUserTupleSchemeFactory());
  }

  public String serviceId; // required
  public long userIds; // required
  public double credit; // required
  public String remark; // required
  public String ipAddress; // required
  public long aliasId; // required
  public boolean isAliasActivity; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    SERVICE_ID((short)1, "serviceId"),
    USER_IDS((short)2, "userIds"),
    CREDIT((short)3, "credit"),
    REMARK((short)4, "remark"),
    IP_ADDRESS((short)5, "ipAddress"),
    ALIAS_ID((short)6, "aliasId"),
    IS_ALIAS_ACTIVITY((short)7, "isAliasActivity");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // SERVICE_ID
          return SERVICE_ID;
        case 2: // USER_IDS
          return USER_IDS;
        case 3: // CREDIT
          return CREDIT;
        case 4: // REMARK
          return REMARK;
        case 5: // IP_ADDRESS
          return IP_ADDRESS;
        case 6: // ALIAS_ID
          return ALIAS_ID;
        case 7: // IS_ALIAS_ACTIVITY
          return IS_ALIAS_ACTIVITY;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __USERIDS_ISSET_ID = 0;
  private static final int __CREDIT_ISSET_ID = 1;
  private static final int __ALIASID_ISSET_ID = 2;
  private static final int __ISALIASACTIVITY_ISSET_ID = 3;
  private byte __isset_bitfield = 0;
  public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.SERVICE_ID, new org.apache.thrift.meta_data.FieldMetaData("serviceId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.USER_IDS, new org.apache.thrift.meta_data.FieldMetaData("userIds", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    tmpMap.put(_Fields.CREDIT, new org.apache.thrift.meta_data.FieldMetaData("credit", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE)));
    tmpMap.put(_Fields.REMARK, new org.apache.thrift.meta_data.FieldMetaData("remark", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.IP_ADDRESS, new org.apache.thrift.meta_data.FieldMetaData("ipAddress", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.ALIAS_ID, new org.apache.thrift.meta_data.FieldMetaData("aliasId", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    tmpMap.put(_Fields.IS_ALIAS_ACTIVITY, new org.apache.thrift.meta_data.FieldMetaData("isAliasActivity", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.BOOL)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(ThriftTransferPtPlForUser.class, metaDataMap);
  }

  public ThriftTransferPtPlForUser() {
  }

  public ThriftTransferPtPlForUser(
    String serviceId,
    long userIds,
    double credit,
    String remark,
    String ipAddress,
    long aliasId,
    boolean isAliasActivity)
  {
    this();
    this.serviceId = serviceId;
    this.userIds = userIds;
    setUserIdsIsSet(true);
    this.credit = credit;
    setCreditIsSet(true);
    this.remark = remark;
    this.ipAddress = ipAddress;
    this.aliasId = aliasId;
    setAliasIdIsSet(true);
    this.isAliasActivity = isAliasActivity;
    setIsAliasActivityIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public ThriftTransferPtPlForUser(ThriftTransferPtPlForUser other) {
    __isset_bitfield = other.__isset_bitfield;
    if (other.isSetServiceId()) {
      this.serviceId = other.serviceId;
    }
    this.userIds = other.userIds;
    this.credit = other.credit;
    if (other.isSetRemark()) {
      this.remark = other.remark;
    }
    if (other.isSetIpAddress()) {
      this.ipAddress = other.ipAddress;
    }
    this.aliasId = other.aliasId;
    this.isAliasActivity = other.isAliasActivity;
  }

  public ThriftTransferPtPlForUser deepCopy() {
    return new ThriftTransferPtPlForUser(this);
  }

  @Override
  public void clear() {
    this.serviceId = null;
    setUserIdsIsSet(false);
    this.userIds = 0;
    setCreditIsSet(false);
    this.credit = 0.0;
    this.remark = null;
    this.ipAddress = null;
    setAliasIdIsSet(false);
    this.aliasId = 0;
    setIsAliasActivityIsSet(false);
    this.isAliasActivity = false;
  }

  public String getServiceId() {
    return this.serviceId;
  }

  public ThriftTransferPtPlForUser setServiceId(String serviceId) {
    this.serviceId = serviceId;
    return this;
  }

  public void unsetServiceId() {
    this.serviceId = null;
  }

  /** Returns true if field serviceId is set (has been assigned a value) and false otherwise */
  public boolean isSetServiceId() {
    return this.serviceId != null;
  }

  public void setServiceIdIsSet(boolean value) {
    if (!value) {
      this.serviceId = null;
    }
  }

  public long getUserIds() {
    return this.userIds;
  }

  public ThriftTransferPtPlForUser setUserIds(long userIds) {
    this.userIds = userIds;
    setUserIdsIsSet(true);
    return this;
  }

  public void unsetUserIds() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __USERIDS_ISSET_ID);
  }

  /** Returns true if field userIds is set (has been assigned a value) and false otherwise */
  public boolean isSetUserIds() {
    return EncodingUtils.testBit(__isset_bitfield, __USERIDS_ISSET_ID);
  }

  public void setUserIdsIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __USERIDS_ISSET_ID, value);
  }

  public double getCredit() {
    return this.credit;
  }

  public ThriftTransferPtPlForUser setCredit(double credit) {
    this.credit = credit;
    setCreditIsSet(true);
    return this;
  }

  public void unsetCredit() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __CREDIT_ISSET_ID);
  }

  /** Returns true if field credit is set (has been assigned a value) and false otherwise */
  public boolean isSetCredit() {
    return EncodingUtils.testBit(__isset_bitfield, __CREDIT_ISSET_ID);
  }

  public void setCreditIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __CREDIT_ISSET_ID, value);
  }

  public String getRemark() {
    return this.remark;
  }

  public ThriftTransferPtPlForUser setRemark(String remark) {
    this.remark = remark;
    return this;
  }

  public void unsetRemark() {
    this.remark = null;
  }

  /** Returns true if field remark is set (has been assigned a value) and false otherwise */
  public boolean isSetRemark() {
    return this.remark != null;
  }

  public void setRemarkIsSet(boolean value) {
    if (!value) {
      this.remark = null;
    }
  }

  public String getIpAddress() {
    return this.ipAddress;
  }

  public ThriftTransferPtPlForUser setIpAddress(String ipAddress) {
    this.ipAddress = ipAddress;
    return this;
  }

  public void unsetIpAddress() {
    this.ipAddress = null;
  }

  /** Returns true if field ipAddress is set (has been assigned a value) and false otherwise */
  public boolean isSetIpAddress() {
    return this.ipAddress != null;
  }

  public void setIpAddressIsSet(boolean value) {
    if (!value) {
      this.ipAddress = null;
    }
  }

  public long getAliasId() {
    return this.aliasId;
  }

  public ThriftTransferPtPlForUser setAliasId(long aliasId) {
    this.aliasId = aliasId;
    setAliasIdIsSet(true);
    return this;
  }

  public void unsetAliasId() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __ALIASID_ISSET_ID);
  }

  /** Returns true if field aliasId is set (has been assigned a value) and false otherwise */
  public boolean isSetAliasId() {
    return EncodingUtils.testBit(__isset_bitfield, __ALIASID_ISSET_ID);
  }

  public void setAliasIdIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __ALIASID_ISSET_ID, value);
  }

  public boolean isIsAliasActivity() {
    return this.isAliasActivity;
  }

  public ThriftTransferPtPlForUser setIsAliasActivity(boolean isAliasActivity) {
    this.isAliasActivity = isAliasActivity;
    setIsAliasActivityIsSet(true);
    return this;
  }

  public void unsetIsAliasActivity() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __ISALIASACTIVITY_ISSET_ID);
  }

  /** Returns true if field isAliasActivity is set (has been assigned a value) and false otherwise */
  public boolean isSetIsAliasActivity() {
    return EncodingUtils.testBit(__isset_bitfield, __ISALIASACTIVITY_ISSET_ID);
  }

  public void setIsAliasActivityIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __ISALIASACTIVITY_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case SERVICE_ID:
      if (value == null) {
        unsetServiceId();
      } else {
        setServiceId((String)value);
      }
      break;

    case USER_IDS:
      if (value == null) {
        unsetUserIds();
      } else {
        setUserIds((Long)value);
      }
      break;

    case CREDIT:
      if (value == null) {
        unsetCredit();
      } else {
        setCredit((Double)value);
      }
      break;

    case REMARK:
      if (value == null) {
        unsetRemark();
      } else {
        setRemark((String)value);
      }
      break;

    case IP_ADDRESS:
      if (value == null) {
        unsetIpAddress();
      } else {
        setIpAddress((String)value);
      }
      break;

    case ALIAS_ID:
      if (value == null) {
        unsetAliasId();
      } else {
        setAliasId((Long)value);
      }
      break;

    case IS_ALIAS_ACTIVITY:
      if (value == null) {
        unsetIsAliasActivity();
      } else {
        setIsAliasActivity((Boolean)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case SERVICE_ID:
      return getServiceId();

    case USER_IDS:
      return Long.valueOf(getUserIds());

    case CREDIT:
      return Double.valueOf(getCredit());

    case REMARK:
      return getRemark();

    case IP_ADDRESS:
      return getIpAddress();

    case ALIAS_ID:
      return Long.valueOf(getAliasId());

    case IS_ALIAS_ACTIVITY:
      return Boolean.valueOf(isIsAliasActivity());

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case SERVICE_ID:
      return isSetServiceId();
    case USER_IDS:
      return isSetUserIds();
    case CREDIT:
      return isSetCredit();
    case REMARK:
      return isSetRemark();
    case IP_ADDRESS:
      return isSetIpAddress();
    case ALIAS_ID:
      return isSetAliasId();
    case IS_ALIAS_ACTIVITY:
      return isSetIsAliasActivity();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof ThriftTransferPtPlForUser)
      return this.equals((ThriftTransferPtPlForUser)that);
    return false;
  }

  public boolean equals(ThriftTransferPtPlForUser that) {
    if (that == null)
      return false;

    boolean this_present_serviceId = true && this.isSetServiceId();
    boolean that_present_serviceId = true && that.isSetServiceId();
    if (this_present_serviceId || that_present_serviceId) {
      if (!(this_present_serviceId && that_present_serviceId))
        return false;
      if (!this.serviceId.equals(that.serviceId))
        return false;
    }

    boolean this_present_userIds = true;
    boolean that_present_userIds = true;
    if (this_present_userIds || that_present_userIds) {
      if (!(this_present_userIds && that_present_userIds))
        return false;
      if (this.userIds != that.userIds)
        return false;
    }

    boolean this_present_credit = true;
    boolean that_present_credit = true;
    if (this_present_credit || that_present_credit) {
      if (!(this_present_credit && that_present_credit))
        return false;
      if (this.credit != that.credit)
        return false;
    }

    boolean this_present_remark = true && this.isSetRemark();
    boolean that_present_remark = true && that.isSetRemark();
    if (this_present_remark || that_present_remark) {
      if (!(this_present_remark && that_present_remark))
        return false;
      if (!this.remark.equals(that.remark))
        return false;
    }

    boolean this_present_ipAddress = true && this.isSetIpAddress();
    boolean that_present_ipAddress = true && that.isSetIpAddress();
    if (this_present_ipAddress || that_present_ipAddress) {
      if (!(this_present_ipAddress && that_present_ipAddress))
        return false;
      if (!this.ipAddress.equals(that.ipAddress))
        return false;
    }

    boolean this_present_aliasId = true;
    boolean that_present_aliasId = true;
    if (this_present_aliasId || that_present_aliasId) {
      if (!(this_present_aliasId && that_present_aliasId))
        return false;
      if (this.aliasId != that.aliasId)
        return false;
    }

    boolean this_present_isAliasActivity = true;
    boolean that_present_isAliasActivity = true;
    if (this_present_isAliasActivity || that_present_isAliasActivity) {
      if (!(this_present_isAliasActivity && that_present_isAliasActivity))
        return false;
      if (this.isAliasActivity != that.isAliasActivity)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    List<Object> list = new ArrayList<Object>();

    boolean present_serviceId = true && (isSetServiceId());
    list.add(present_serviceId);
    if (present_serviceId)
      list.add(serviceId);

    boolean present_userIds = true;
    list.add(present_userIds);
    if (present_userIds)
      list.add(userIds);

    boolean present_credit = true;
    list.add(present_credit);
    if (present_credit)
      list.add(credit);

    boolean present_remark = true && (isSetRemark());
    list.add(present_remark);
    if (present_remark)
      list.add(remark);

    boolean present_ipAddress = true && (isSetIpAddress());
    list.add(present_ipAddress);
    if (present_ipAddress)
      list.add(ipAddress);

    boolean present_aliasId = true;
    list.add(present_aliasId);
    if (present_aliasId)
      list.add(aliasId);

    boolean present_isAliasActivity = true;
    list.add(present_isAliasActivity);
    if (present_isAliasActivity)
      list.add(isAliasActivity);

    return list.hashCode();
  }

  @Override
  public int compareTo(ThriftTransferPtPlForUser other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetServiceId()).compareTo(other.isSetServiceId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetServiceId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.serviceId, other.serviceId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetUserIds()).compareTo(other.isSetUserIds());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetUserIds()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.userIds, other.userIds);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetCredit()).compareTo(other.isSetCredit());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetCredit()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.credit, other.credit);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetRemark()).compareTo(other.isSetRemark());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRemark()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.remark, other.remark);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIpAddress()).compareTo(other.isSetIpAddress());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIpAddress()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.ipAddress, other.ipAddress);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetAliasId()).compareTo(other.isSetAliasId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetAliasId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.aliasId, other.aliasId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIsAliasActivity()).compareTo(other.isSetIsAliasActivity());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIsAliasActivity()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.isAliasActivity, other.isAliasActivity);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("ThriftTransferPtPlForUser(");
    boolean first = true;

    sb.append("serviceId:");
    if (this.serviceId == null) {
      sb.append("null");
    } else {
      sb.append(this.serviceId);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("userIds:");
    sb.append(this.userIds);
    first = false;
    if (!first) sb.append(", ");
    sb.append("credit:");
    sb.append(this.credit);
    first = false;
    if (!first) sb.append(", ");
    sb.append("remark:");
    if (this.remark == null) {
      sb.append("null");
    } else {
      sb.append(this.remark);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("ipAddress:");
    if (this.ipAddress == null) {
      sb.append("null");
    } else {
      sb.append(this.ipAddress);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("aliasId:");
    sb.append(this.aliasId);
    first = false;
    if (!first) sb.append(", ");
    sb.append("isAliasActivity:");
    sb.append(this.isAliasActivity);
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class ThriftTransferPtPlForUserStandardSchemeFactory implements SchemeFactory {
    public ThriftTransferPtPlForUserStandardScheme getScheme() {
      return new ThriftTransferPtPlForUserStandardScheme();
    }
  }

  private static class ThriftTransferPtPlForUserStandardScheme extends StandardScheme<ThriftTransferPtPlForUser> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, ThriftTransferPtPlForUser struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // SERVICE_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.serviceId = iprot.readString();
              struct.setServiceIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // USER_IDS
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.userIds = iprot.readI64();
              struct.setUserIdsIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // CREDIT
            if (schemeField.type == org.apache.thrift.protocol.TType.DOUBLE) {
              struct.credit = iprot.readDouble();
              struct.setCreditIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 4: // REMARK
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.remark = iprot.readString();
              struct.setRemarkIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 5: // IP_ADDRESS
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.ipAddress = iprot.readString();
              struct.setIpAddressIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 6: // ALIAS_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.aliasId = iprot.readI64();
              struct.setAliasIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 7: // IS_ALIAS_ACTIVITY
            if (schemeField.type == org.apache.thrift.protocol.TType.BOOL) {
              struct.isAliasActivity = iprot.readBool();
              struct.setIsAliasActivityIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, ThriftTransferPtPlForUser struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.serviceId != null) {
        oprot.writeFieldBegin(SERVICE_ID_FIELD_DESC);
        oprot.writeString(struct.serviceId);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(USER_IDS_FIELD_DESC);
      oprot.writeI64(struct.userIds);
      oprot.writeFieldEnd();
      oprot.writeFieldBegin(CREDIT_FIELD_DESC);
      oprot.writeDouble(struct.credit);
      oprot.writeFieldEnd();
      if (struct.remark != null) {
        oprot.writeFieldBegin(REMARK_FIELD_DESC);
        oprot.writeString(struct.remark);
        oprot.writeFieldEnd();
      }
      if (struct.ipAddress != null) {
        oprot.writeFieldBegin(IP_ADDRESS_FIELD_DESC);
        oprot.writeString(struct.ipAddress);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(ALIAS_ID_FIELD_DESC);
      oprot.writeI64(struct.aliasId);
      oprot.writeFieldEnd();
      oprot.writeFieldBegin(IS_ALIAS_ACTIVITY_FIELD_DESC);
      oprot.writeBool(struct.isAliasActivity);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class ThriftTransferPtPlForUserTupleSchemeFactory implements SchemeFactory {
    public ThriftTransferPtPlForUserTupleScheme getScheme() {
      return new ThriftTransferPtPlForUserTupleScheme();
    }
  }

  private static class ThriftTransferPtPlForUserTupleScheme extends TupleScheme<ThriftTransferPtPlForUser> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, ThriftTransferPtPlForUser struct) throws org.apache.thrift.TException {
      TTupleProtocol oprot = (TTupleProtocol) prot;
      BitSet optionals = new BitSet();
      if (struct.isSetServiceId()) {
        optionals.set(0);
      }
      if (struct.isSetUserIds()) {
        optionals.set(1);
      }
      if (struct.isSetCredit()) {
        optionals.set(2);
      }
      if (struct.isSetRemark()) {
        optionals.set(3);
      }
      if (struct.isSetIpAddress()) {
        optionals.set(4);
      }
      if (struct.isSetAliasId()) {
        optionals.set(5);
      }
      if (struct.isSetIsAliasActivity()) {
        optionals.set(6);
      }
      oprot.writeBitSet(optionals, 7);
      if (struct.isSetServiceId()) {
        oprot.writeString(struct.serviceId);
      }
      if (struct.isSetUserIds()) {
        oprot.writeI64(struct.userIds);
      }
      if (struct.isSetCredit()) {
        oprot.writeDouble(struct.credit);
      }
      if (struct.isSetRemark()) {
        oprot.writeString(struct.remark);
      }
      if (struct.isSetIpAddress()) {
        oprot.writeString(struct.ipAddress);
      }
      if (struct.isSetAliasId()) {
        oprot.writeI64(struct.aliasId);
      }
      if (struct.isSetIsAliasActivity()) {
        oprot.writeBool(struct.isAliasActivity);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, ThriftTransferPtPlForUser struct) throws org.apache.thrift.TException {
      TTupleProtocol iprot = (TTupleProtocol) prot;
      BitSet incoming = iprot.readBitSet(7);
      if (incoming.get(0)) {
        struct.serviceId = iprot.readString();
        struct.setServiceIdIsSet(true);
      }
      if (incoming.get(1)) {
        struct.userIds = iprot.readI64();
        struct.setUserIdsIsSet(true);
      }
      if (incoming.get(2)) {
        struct.credit = iprot.readDouble();
        struct.setCreditIsSet(true);
      }
      if (incoming.get(3)) {
        struct.remark = iprot.readString();
        struct.setRemarkIsSet(true);
      }
      if (incoming.get(4)) {
        struct.ipAddress = iprot.readString();
        struct.setIpAddressIsSet(true);
      }
      if (incoming.get(5)) {
        struct.aliasId = iprot.readI64();
        struct.setAliasIdIsSet(true);
      }
      if (incoming.get(6)) {
        struct.isAliasActivity = iprot.readBool();
        struct.setIsAliasActivityIsSet(true);
      }
    }
  }

}

